package com.capitalware.ufmsm.renders;
/**
 *
 *
 */

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * This class will set the odd numbered rows to a light grey.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class WorkflowRender extends DefaultTableCellRenderer
{
   private static final Color LightLightGray = new Color(247,247,247);

   /**
    * The constructor
    */
   public WorkflowRender()
   {
      setHorizontalAlignment(SwingConstants.CENTER);
   }


   public Component getTableCellRendererComponent(JTable table,
                                                  Object value,
                                                  boolean isSelected,
                                                  boolean hasFocus,
                                                  int row,
                                                  int column)
   {
      super.getTableCellRendererComponent(table,value,isSelected,hasFocus,row,column);

      if (isSelected)
      {
         return this;
      }
      else
      {
         if ( (column == 1)  &&
              (value instanceof String) )
         {
            if (!("0".equals(((String) value).trim())))
            {
               setForeground(isSelected ? Color.red   : Color.white);
               setBackground(isSelected ? Color.white : Color.red);
            }
            else
            {
               setForeground(table.getForeground());
               setBackground( (row & 1) == 1 ? table.getBackground() : LightLightGray );
            }
         }
         else
         {
            setForeground(table.getForeground());
            setBackground( (row & 1) == 1 ? table.getBackground() : LightLightGray );
         }
      }

      /*
       * Implementation Note :
       * It is important that no "new" be present in this implementation (excluding exceptions):
       * if the table is large, then a large number of objects would be
       * created during rendering.
       */
      if (value == null)
         return this;

      return this;
   }
}
